Object Properties Manager
Description
Object Properties Manager (OPM) is a COM-based feature that examines properties of objects and provides an interface for editing and adding properties to the object(s). The properties palette uses COM to communicate with the object(s) in question, and requires C++ to expose particular interfaces that control the display of the properties in the palette.
By extending Object Properties Manager, you can display custom properties for both native and custom objects and enhance their appearance in the Properties palette.
Examples
The solution contains 3 projects:
OPMCustomEntity implements and registers a basic custom entity. Besides that WHEEL command creates and adds the entity to the model space.
OPMComEntity contains the COM interfaces that are used to wrap the custom entity properties fields on the Properties palette. To support OPM properties the OPMComEntity module must be registered.
OPMDynamicProperties implements the custom entity dynamic properties. OPMDynamicProperties is the option for those developers that want to associate custom dynamic properties to entities.
Put the Examples to Work
Update examples .PROPS file to point to your installed FxARX SDK headers and libraries.
Build the projects and make sure the COM wrapper (OPMComEntity) is registered. Just a reminder, the module can be registered automatically when you load the app if ARES Commander is running with admin rights.
Load the modules with APPLOAD command in this order: OPMCustomEntity.frx → OPMComEntity → OPMDynamicProperties.frx
Run WHEEL command, select the created entity and open the properties palette
(in green the areas that are shown by the OPM) if you play with the geometry fields you will see how the wheel entity is updated.
Breaking Down OPM examples
OPMCustomEntity is very similar to any custom entity implemententation. Take in account that you need to override custom entity method subGetClassID( CLSID* pClsid ) to point to the GUID of the COM interface:
Acad::ErrorStatus CWheel::subGetClassID( CLSID* pClsid ) const
{
assertReadEnabled();
*pClsid = CLSID_COMWheel;
return Acad::eOk;
}
OPMComEntity is an ATL project. So, some experience in ATL development is a advantage. An ATL project can be automatically generated using the Visual Studio Wizard for ATL. Then the generated classes are implemented using OPM and FxARX API. We adapted the project to include FRX acrxEntryPoint and acrxGetApiVersion methods.
Review specially COMWheel/cpp files, which were originally generated with the ATL wizard. During that process, it is added the static properties: radius, location and NumberOfSpokes with empty functions. Finally, we fill the functions up ourselves as follows:
STDMETHODIMP CCOMWheel::put_NumberOfSpokes( SHORT newVal )
{
try
{
Acad::ErrorStatus es;
AcAxObjectRefPtr<CWheel> pWheel( &m_objRef, AcDb::kForWrite, Adesk::kTrue );
if ( (es = pWheel.openStatus()) != Acad::eOk )
throw es;
USES_CONVERSION;
pWheel->setNumSpokes( newVal );
}
catch ( const Acad::ErrorStatus )
{
return E_FAIL;
}
return S_OK;
}
OPMDynamicProperties shows how to implement dynamic properties. In this case, the example defines 2 new properties for the CWheel custom entity: Brand and Warranty. The information of those 2 properties is maintained as XDATA. Please take a look at the file WheelDynamicProperties.cpp.
Finally, the properties need to be assigned to the CWheel class declaring the macro OPM_DYNPROP_OBJECT_ENTRY_AUTO
OPM_DYNPROP_OBJECT_ENTRY_AUTO( CWheelBrand, CWheel );
OPM_DYNPROP_OBJECT_ENTRY_AUTO( CWheelWarranty, CWheel );
For extending ARES Commander native entity properties, use as second parameter the entity class name that you want to expand, i.e.:
OPM_DYNPROP_OBJECT_ENTRY_AUTO( CMyNewLineProperty, AcDbLine);
For zero selection mode, map your property to the AcDbDatabase:
OPM_DYNPROP_OBJECT_ENTRY_AUTO( CMyNewLineProperty, AcDbDatabase);
Tools palette
Please read the following documentation: Custom Tool Palettes